// OTT mirror
// Copyright (C) 2014 Balthasar Szczepański
// post.cpp
// write posts from the mirror.
// 24.09.2014
//
// This file is part of OTT mirror.
//
// OTT mirror is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affreo General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// OTT mirror is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affreo General Public License for more details.
// 
// You should have received a copy of the GNU Affreo General Public License
// along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

#include <cgi.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/wait.h>

###RM_PATH
###MV_PATH
###CAT_PATH
###MAWK_PATH

###POST_PATH
###INFO_PATH
###MPOST_PATH
###MLIST_PATH
###MLAST_PATH
###MFRONT_PATH

###AWK_PREVIEW
###AWK_VIEW
###TEMP_PATHp
###AWK_B2H
###AWK_VERIFY

s_cgi *cgi;
pid_t sub;
int r;
FILE *tempfile;
FILE *postfile;
bool tf=false;
bool pf=false;
char temppath[256]="";
char postpath[256]="";

char zero='\0';
char *username = &zero;
char *password = &zero;
char *subject = &zero;
char *message = &zero;
char *addbbcode20 = &zero;
char *disable_bbcode = &zero;
char *disable_smilies = &zero;
char *disable_magic_url = &zero;
char *attach_sig = &zero;
char *notify = &zero;
char *Preview = &zero;
char *post =&zero;
char *addquote =&zero;
char *edit =&zero;
char *forceID =&zero;
char wrong[256];

void submit();
void preview (const char *text);
void writeArg(FILE *file,const char *name,const char *value, bool all);
void writeArg(FILE *file,const char *name,const char *value, char *insert);
void writeArgH(FILE *file,const char *name,const char *value, unsigned char br);
void writeArgH(FILE *file,const char *value);
void end(int m);

void end(int m)
{
	if(tf)
		fclose(tempfile);
	if(pf)
		fclose(postfile);
	sub=fork();
	if(sub==0)
	{
		r=execl(RM_PATH,RM_PATH,"-f",temppath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(pf)
	{
		sub=fork();
		if(sub==0)
		{
			r=execl(RM_PATH,RM_PATH,"-f",postpath,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
	}
	exit(m);
}

void writeArg(FILE *file,const char *name,const char *value, bool all=false)
{
	unsigned short length, i, v;
	fprintf(file,"%s=",name);
	for(i=0, length=strlen(value);i<length;++i)
	{
		v=((unsigned short)value[i])&0x00ff;
		if(((value[i]>='0'&&value[i]<='9')||(value[i]>='A'&&value[i]<='Z')||(value[i]>='a'&&value[i]<='z')
		||value[i]=='.'||value[i]=='~'||value[i]=='-'||value[i]=='_')&&(!all))
			fputc(v,file);
		else
			fprintf(file,"%%%02X",v);
	}
	fputc('\n',file);
}

void writeArg(FILE *file,const char *name,const char *value, char *insert)
{
	unsigned short length, i, v;
	fprintf(file,"%s=",name);
	for(i=0, length=strlen(insert);i<length;++i)
	{
		v=((unsigned short)insert[i])&0x00ff;
		if((insert[i]>='0'&&insert[i]<='9')||(insert[i]>='A'&&insert[i]<='Z')||(insert[i]>='a'&&insert[i]<='z')
		||insert[i]=='.'||insert[i]=='~'||insert[i]=='-'||insert[i]=='_')
			fputc(v,file);
		else
			fprintf(file,"%%%02X",v);
	}
	for(i=0, length=strlen(value);i<length;++i)
	{
		v=((unsigned short)value[i])&0x00ff;
		if((value[i]>='0'&&value[i]<='9')||(value[i]>='A'&&value[i]<='Z')||(value[i]>='a'&&value[i]<='z')
		||value[i]=='.'||value[i]=='~'||value[i]=='-'||value[i]=='_')
			fputc(v,file);
		else
			fprintf(file,"%%%02X",v);
	}
	fputc('\n',file);
}

void writeArgH(FILE *file,const char *name,const char *value, unsigned char br=0)
{
	unsigned short length, i, v;
	fprintf(file,"%s=",name);
	for(i=0, length=strlen(value);i<length;++i)
	{
		v=((unsigned short)value[i])&0x00ff;
		switch (value[i])
		{
		case '\"':
		case ' ':
			if(br&0x02)
			{
				fputc(v,file);
				break;
			}
			else
			{
				fprintf(file,"&#%hu;",v);
				break;
			}
		case '\n':
			if(br&0x01)
				fprintf(file,"<br/>");
		case '\r':
			if(br&0x01)
				break;
		case '=':
		case '<':
		case '>':
		case '&':
			fprintf(file,"&#%hu;",v);
			break;
		default:
			fputc(v,file);
		}
	}
	fputc('\n',file);
}

void writeArgH(FILE *file,const char *value)
{
	unsigned short length, i, v;
	for(i=0, length=strlen(value);i<length;++i)
	{
		v=((unsigned short)value[i])&0x00ff;
		switch (value[i])
		{
		case '\"':
		case '&':
		case '<':
		case '>':
		case ' ':
		case '\r':
		case '\n':
		case '=':
			fprintf(file,"&#%hu;",v);
			break;
		default:
			fputc(v,file);
		}
	}
}

void submit()
{
	time_t posttime;
	char timetext[32];
	char timenumber[32];
	char botinfo[256];
	char arg1[256];
	char arg2[256];
	
	unsigned long lastpage;
	unsigned short postslast;
	char listpath[256];
	
	posttime=time(NULL);
	if(forceID[0]!='\0')
		sprintf(timenumber,"%s",forceID);
	else
		sprintf(timenumber,"%llu",(unsigned long long)posttime);
	strftime(timetext,31,"%a %b %d, %Y %I:%M %p %Z",gmtime(&posttime));
	if(*disable_bbcode=='\0')
		sprintf(botinfo,"[Posted from the Mirror at %s%s]\r\n",timetext,(forceID[0]!='\0')?", edited":"");
	else
		sprintf(botinfo,"[size=80][Posted from the Mirror at %s%s][/size]\r\n",timetext,(forceID[0]!='\0')?", edited":"");
	sprintf(postpath,"%s%s",MPOST_PATH,timenumber);
	
	tempfile=fopen(temppath,"wt");
	if(tempfile==NULL)
		preview("Couldn't create file.");
	tf=true;
	writeArgH(tempfile,"timenumber",timenumber);
	writeArgH(tempfile,"timetext",timetext);
	writeArgH(tempfile,"BBHTML",message,1);
	writeArgH(tempfile,"BB",message,3);
	writeArgH(tempfile,"username_h",username);
	writeArgH(tempfile,"subject_h",subject);
	writeArg (tempfile,"username",username);
	writeArg (tempfile,"password",password,1);
	writeArg (tempfile,"subject",subject);
	writeArg (tempfile,"addbbcode20",addbbcode20);
	writeArg (tempfile,"message",message,botinfo);
	if(disable_bbcode[0]!='\0')
		writeArg(tempfile,"disable_bbcode",disable_bbcode);
	if(disable_smilies[0]!='\0')
		writeArg(tempfile,"disable_smilies",disable_smilies);
	if(disable_magic_url[0]!='\0')
		writeArg(tempfile,"disable_magic_url",disable_magic_url);
	if(attach_sig[0]!='\0')
		writeArg(tempfile,"attach_sig",attach_sig);
	if(notify[0]!='\0')
		writeArg(tempfile,"notify",notify);
	fclose(tempfile);
	tf=false;
	
	sprintf(arg1,"outfile=%s",temppath);
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		setvbuf(stdout, NULL, _IONBF, 0);
		dup2(fileno(stdout),fileno(stderr));
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_B2H,"-v",arg1,temppath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	
	sprintf(arg1,"name=%s",username);
	sprintf(arg2,"pass=%s",password);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_VERIFY,"-v",arg1,"-v",arg2,"-v","reversed=1",postpath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(!r)
		preview("Can't replace this post. Not yours or wrong password?");
		
	sub=fork();
	if(sub==0)
	{
		r=execl(MV_PATH,MV_PATH,temppath,postpath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("Couldn't add post to queue.");
	
	if(forceID[0]=='\0')
	{
		tempfile=fopen(MLAST_PATH,"rt");
		if(tempfile==NULL)
		{
			lastpage=1;
			postslast=1;
		}
		else
		{
			tf=true;
			if(fgets(listpath,255,tempfile))
				sscanf(listpath,"%lu",&lastpage);
			if(fgets(listpath,255,tempfile))
				sscanf(listpath,"%hu",&postslast);
			if(postslast>=40)
			{
				++lastpage;
				postslast=0;
			}
			else
				++postslast;
			fclose(tempfile);
			tf=false;
		}
		tempfile=fopen(MLAST_PATH,"wt");
		if(tempfile==NULL)
		{
			pf=true;
			preview("Couldn't update list.");
		}
		fprintf(tempfile,"%lu\n%hu\n%s\n",lastpage,postslast,timenumber);
		fclose(tempfile);
		
		sprintf(listpath,"%s%lu",MLIST_PATH,lastpage);
		tempfile=fopen(listpath,"at");
		if(tempfile==NULL)
		{
			pf=true;
			preview("Couldn't update list.");
		}
		fprintf(tempfile,"%s\n",timenumber);
		fclose(tempfile);
		
		tempfile=fopen(MFRONT_PATH,"wt");
		if(tempfile!=NULL)
		{
			fprintf(tempfile,"<li class=\"row bg2\" >\n");
			fprintf(tempfile,"<dl class=\"icon\" style=\"background-image: url(/ott/prosilver/imageset/topic_mustard.gif); background-repeat: no-repeat;\" >\n");
			fprintf(tempfile,"<dt title=\"No unread posts\" ><a href=\"/ott/mview\" class=\"topictitle\" >Mustardtime Otherthread</a>\n");
			fprintf(tempfile,"<br />\nMustardtime posts will be shown here, before they are posted to the OTT.<br />\n");
			fprintf(tempfile,"<strong class=\"pagination\" ><span>");
			if(lastpage>5)
				fprintf(tempfile,"<a href=\"/ott/mview\" >1</a><span class=\"page-dots\" > ... </span>");
			for(unsigned long i=((lastpage>5)?(lastpage-2):1);i<lastpage;++i)
				fprintf(tempfile,"<a href=\"/ott/mview?np=%lu\" >%lu</a><span class=\"page-sep\" >, </span>",i,i);
			fprintf(tempfile,"<a href=\"/ott/mview?np=%lu\" >%lu</a>",lastpage,lastpage);
			fprintf(tempfile,"</span></strong><img src=\"/ott/prosilver/imageset/icon_topic_attach.gif\" width=\"7\" height=\"10\" alt=\"Attachment(s)\" title=\"Attachment(s)\" /> by <a href=\"http://1190.bicyclesonthemoon.dnsd.info/bothasar_p/\" >bothasar_p</a> &raquo; Sat Apr 05, 2014 9:40 pm UTC</dt>\n");
			fprintf(tempfile,"<dd class=\"posts\" >%lu <dfn>Replies</dfn></dd>\n",(unsigned long)((lastpage-1)*40+postslast));
			fprintf(tempfile,"<dd class=\"views\" >NaN <dfn>Views</dfn></dd>\n");
			fprintf(tempfile,"<dd class=\"lastpost\" ><span><dfn>Last post </dfn>by <a href=\"#\" >");
			writeArgH(tempfile,username);
			fprintf(tempfile,"</a>\n<a href=\"/ott/mview?np=%lu&amp;p=%s#m%s\" ><img src=\"/ott/prosilver/imageset/icon_topic_latest.gif\" width=\"11\" height=\"9\" alt=\"View the latest post\" title=\"View the latest post\" /></a> <br />%s</span>\n",lastpage,timenumber,timenumber,timetext);
			fprintf(tempfile,"</dd>\n</dl>\n</li>\n");
		}
		fclose(tempfile);
		sprintf(arg1,"info=<p>This message has been posted successfully.<br /><br /><a href=\"/ott/mview?np=%lu&amp;p=%s#m%s\">View your submitted message</a><br /><br /><a href=\"/ott/\">Return to the ЯOЯЯIM TTO</a></p>",lastpage,timenumber,timenumber);

	}
	else
		sprintf(arg1,"info=<p>This message has been posted successfully.<br /><br /><a href=\"/ott/mview?p=%s#m%s\">View your submitted message</a><br /><br /><a href=\"/ott/\">Return to the ЯOЯЯIM TTO</a></p>",timenumber,timenumber);
	
	printf("Content-type: text/html\n\n");
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_VIEW,"-v",arg1,INFO_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<HTML><body>%s</body></html>",arg1);
	end(0);
}
void preview (const char *text)
{
	char arg1[256];
	tempfile=fopen(temppath,"wt");
	if(tempfile==NULL)
		end(1);
	tf=true;
	
	writeArgH(tempfile,"HTML",message,1);
	writeArgH(tempfile,"BB",message,3);
	writeArgH(tempfile,"wrong",text);
	writeArgH(tempfile,"username",username);
	writeArgH(tempfile,"subject",subject);
	writeArgH(tempfile,"message",message);
	// writeArgH(tempfile,"addbbcode20",addbbcode20);
	writeArgH(tempfile,"disable_bbcode",disable_bbcode);
	writeArgH(tempfile,"disable_smilies",disable_smilies);
	writeArgH(tempfile,"disable_magic_url",disable_magic_url);
	writeArgH(tempfile,"attach_sig",attach_sig);
	writeArgH(tempfile,"notify",notify);
	writeArgH(tempfile,"addquote",addquote);
	writeArgH(tempfile,"edit",edit);
	writeArgH(tempfile,"forceID",forceID);
	// writeArgH(tempfile,"Preview",Preview);
	// writeArgH(tempfile,"post",post);
	
	fclose(tempfile);
	tf=false;
	
	printf("Content-type: text/html\n\n");
	
	sprintf(arg1,"outfile=%s",temppath);
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		setvbuf(stdout, NULL, _IONBF, 0);
		dup2(fileno(stdout),fileno(stderr));
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_B2H,"-v",arg1,temppath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	
	// printf("Content-type: text/html\n\n");
	sprintf(arg1,"argfile=%s",temppath);
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_PREVIEW,"-v",arg1,POST_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<HTML><body><p>Ch*rpin* M*stard</p></body></html>");
	end(0);
}

int main()
{
	bool missing=false;

	
	char *arg;
	
	cgi=cgiInit();
	
	sprintf(temppath,"%s%lu",TEMP_PATH,(unsigned long)getpid());
	
	arg=cgiGetValue(cgi,"password");
	if(arg!=NULL)
		password=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Password is missing.");
	}
	
	arg=cgiGetValue(cgi,"username");
	if(arg!=NULL)
		username=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Username is missing.");
	}
	
	arg=cgiGetValue(cgi,"subject");
	if(arg!=NULL)
		subject=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Subject was missing. Replaced with default value.");
	}
	
	arg=cgiGetValue(cgi,"message");
	if(arg!=NULL)
		message=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Post is empty.");
	}
	
	arg=cgiGetValue(cgi,"addbbcode20");
	if(arg!=NULL)
		addbbcode20=arg;
		
	arg=cgiGetValue(cgi,"disable_bbcode");
	if(arg!=NULL)
		disable_bbcode=arg;
	
	arg=cgiGetValue(cgi,"disable_smilies");
	if(arg!=NULL)
		disable_smilies=arg;
	
	arg=cgiGetValue(cgi,"disable_magic_url");
	if(arg!=NULL)
		disable_magic_url=arg;
	
	arg=cgiGetValue(cgi,"attach_sig");
	if(arg!=NULL)
		attach_sig=arg;
	
	arg=cgiGetValue(cgi,"notify");
	if(arg!=NULL)
		notify=arg;
	
	arg=cgiGetValue(cgi,"Preview");
	if(arg!=NULL)
		Preview=arg;
	
	arg=cgiGetValue(cgi,"post");
	if(arg!=NULL)
		post=arg;
	
	arg=cgiGetValue(cgi,"q");
	if(arg!=NULL)
		addquote=arg;
	
	arg=cgiGetValue(cgi,"e");
	if(arg!=NULL)
		edit=arg;
	
	arg=cgiGetValue(cgi,"forceID");
	if(arg!=NULL)
		forceID=arg;
	
	if(strcmp(post,"Submit")==0)
	{
		if(missing)
			preview(wrong);
		else
			submit();
	}
	else
		preview("");
	
	return 0;
	
}
