# OTT mirror
# Copyright (C) 2014 Balthasar Szczepański
# preview.awk
# insert content into the preview page.
# 24.09.2014

# This file is part of OTT mirror.
#
# OTT mirror is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affreo General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# OTT mirror is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affreo General Public License for more details.
# 
# You should have received a copy of the GNU Affreo General Public License
# along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

BEGIN{
###mpostpath
###okpath
###pmpath
###failpath
	
	HTML="<div class=\"post bg2\" id=\"preview\">\n<div class=\"inner\"><span class=\"corners-top\"><span></span></span>\n<div class=\"postbody\">\n<h3>Preview: %s</h3><div class=\"content\">%s</div></div><span class=\"corners-bottom\"><span></span></span></div></div>\n"
	wrong="<p class=\"error\">%s</p>\n"
	subject="<dd><input type=\"text\" name=\"subject\" id=\"subject\" size=\"45\" maxlength=\"64\" tabindex=\"1\" value=\"%s\" class=\"inputbox autowidth\" /></dd>\n"
	username="<dd><input tabindex=\"2\" name=\"username\" id=\"username\" size=\"45\" value=\"%s\" class=\"inputbox autowidth\" type=\"text\" /></dd>\n"
	message="<textarea name=\"message\" id=\"message\" rows=\"15\" cols=\"76\" tabindex=\"4\" onselect=\"storeCaret(this);\" onclick=\"storeCaret(this);\" onkeyup=\"storeCaret(this);\" onfocus=\"initInsertions();\" class=\"inputbox\" >%s%s</textarea>\n"
	disable_bbcode="<div><label for=\"disable_bbcode\"><input type=\"checkbox\" name=\"disable_bbcode\" id=\"disable_bbcode\" %s /> Disable BBCode</label></div>\n"
	disable_smilies="<div><label for=\"disable_smilies\"><input type=\"checkbox\" name=\"disable_smilies\" id=\"disable_smilies\" %s /> Disable smilies</label></div>\n"
	disable_magic_url="<div><label for=\"disable_magic_url\"><input type=\"checkbox\" name=\"disable_magic_url\" id=\"disable_magic_url\" %s /> Do not automatically parse URLs</label></div>\n"
	attach_sig="<div><label for=\"attach_sig\"><input type=\"checkbox\" name=\"attach_sig\" id=\"attach_sig\" %s /> Attach a signature (signatures can be altered via the UCP)</label></div>\n"
	notify="<div><label for=\"notify\"><input type=\"checkbox\" name=\"notify\" id=\"notify\" %s /> Notify me when a reply is posted</label></div>\n"
	forceID="<input type=\"text\" name=\"forceID\" value=\"%s\"/>\n"
	
	addquote=""
	
	# print "<!--preview.awk:\nargfile=" argfile
	while((getline argline < argfile)>0)
	{
		gsub(/[\r\n]/,"",argline)
		eq=index(argline,"=")
		argtab[substr(argline,1,eq-1)]=substr(argline,eq+1)
		# print substr(argline,1,eq-1) "=" argtab[substr(argline,1,eq-1)]
	}
	# print "-->"
	close(argfile)
	if(argtab["edit"] ~ /^m[0-9]+$/)
	{
		argtab["forceID"]=substr(argtab["edit"],2)
		argfile= mpostpath argtab["forceID"]
		
		while((getline argline < argfile)>0)
		{
			gsub(/[\r\n]/,"",argline)
			eq=index(argline,"=")
			if(argline ~ /^((username)|(subject))_h=/)
				argtab[substr(argline,1,eq-3)]=substr(argline,eq+1)
			else if(argline ~ /^BBHTML=/)
			{
				argtab["message"]=substr(argline,eq+1)
				gsub(/<br>/,"\n",argtab["message"])
			}
			else if(argline ~ /^((BB)|(username)|(subject)|(message)|(HTML)|(debug))=/)
			{}
			else
				argtab[substr(argline,1,eq-1)]=substr(argline,eq+1)
		}
		close(argfile)
	}
	else if(argtab["addquote"] ~ /^(m|(ok)|(pm)|(fl))[0-9]+$/)
	{
		if(argtab["addquote"] ~ /^m[0-9]+$/)
			argfile= mpostpath substr(argtab["addquote"],2)
		if(argtab["addquote"] ~ /^ok[0-9]+$/)
			argfile= okpath substr(argtab["addquote"],3)
		if(argtab["addquote"] ~ /^pm[0-9]+$/)
			argfile= pmpath substr(argtab["addquote"],3)
		if(argtab["addquote"] ~ /^fl[0-9]+$/)
			argfile= failpath substr(argtab["addquote"],3)
		#else
			#argfile is not changed = quote self?
		while((getline argline < argfile)>0)
		{
			gsub(/[\r\n]/,"",argline)
			eq=index(argline,"=")
			if(argline ~ /^BBHTML=/)
			{
				addquotehtml=substr(argline,eq+1)
				gsub(/ ?<br\/> ?/,"\n",addquotehtml)
			}
			if(argline ~ /^username_h=/)
				addquotename=substr(argline,eq+1)
			if(argline ~ /^subject_h/)
			{
				addquotesub=substr(argline,eq+1)
				if(addquotesub ~ /^Re:/)
					argtab["subject"]=addquotesub
				else
					argtab["subject"]="Re: "addquotesub
			}
			if(argline ~ /^timetext/)
			{
				addquotetime=", at "substr(argline,eq+1)
			}
		}
		close(argfile)
		if(addquotehtml!="")
			addquote="[quote=&quot;"addquotename addquotetime"&quot;]"addquotehtml"[/quote]"
	}
};
{
	if ($0 ~ /^###HTML/)
	{
		if((argtab["HTML"]!="")&&(argtab["wrong"]==""))
			printf(HTML,argtab["subject"],argtab["HTML"])
	}
	else if ($0 ~ /^###wrong/)
	{
		if(argtab["wrong"]!="")
			printf(wrong,argtab["wrong"])
	}
	else if ($0 ~ /^###forceID/)
	{
		if(argtab["forceID"]!="")
			printf(forceID,argtab["forceID"])
	}
	else if ($0 ~ /^###subject/)
			printf(subject,((argtab["subject"]=="")?"###default_subject;":argtab["subject"]))
	else if ($0 ~ /^###username/)
		printf(username,argtab["username"])
	else if ($0 ~ /^###message/)
		printf(message,argtab["message"],addquote)
	else if ($0 ~ /^###disable_bbcode/)
		printf(disable_bbcode,(argtab["disable_bbcode"]=="on")?"checked=\"checked\"":"")
	else if ($0 ~ /^###disable_smilies/)
		printf(disable_smilies,(argtab["disable_smilies"]=="on")?"checked=\"checked\"":"")
	else if ($0 ~ /^###disable_magic_url/)
		printf(disable_magic_url,(argtab["disable_magic_url"]=="on")?"checked=\"checked\"":"")
	else if ($0 ~ /^###attach_sig/)
		printf(attach_sig,(argtab["attach_sig"]=="on")?"checked=\"checked\"":"")
	else if ($0 ~ /^###notify/)
		printf(notify,(argtab["notify"]=="on")?"checked=\"checked\"":"")
	else if ($0 ~ /^###debug/)
	{
		gsub(/###nl;/,"\n",argtab["debug"])
		gsub(/-/," - ",argtab["debug"])
		print "<!-- "argtab["debug"]" -->"
	}
	else
		print $0
};