// OTT mirror
// Copyright (C) 2014 Balthasar Szczepański
// view.cpp
// view a page.
// 12.09.2014
//
// This file is part of OTT mirror.
//
// OTT mirror is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affreo General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// OTT mirror is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affreo General Public License for more details.
// 
// You should have received a copy of the GNU Affreo General Public License
// along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

#include <cgi.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

#define RM_PATH "/bin/rm"
#define CAT_PATH "/bin/cat"
#define MAWK_PATH "/usr/bin/mawk"

###NP_TOP_PATH
###NP_END_PATH
###UP_PATH
###POSTLIST_PATH
###SIG_PATHe
###INF_PATHe
###NP_LAST_PATH
###MSTD_LAST_PATH

###AWK_VIEW
###TEMP_PATHv

unsigned long p2np(unsigned long p)
{
	FILE *file;
	char path[256];
	char text[256];
	unsigned long np=0;
	unsigned long np2;
	unsigned long pp;
	
	for(short i=31;i>=0;--i)
	{
		np2 = np + (1L << i);
		sprintf(path,"%s%lu",POSTLIST_PATH,np2);
		file=fopen(path,"rt");
		if(file==NULL)
			continue;
		fgets(text,255,file);
		fclose(file);
		sscanf(text,"%lu",&pp);
		if(pp==p)
			return np2;
		else if(pp<p)
			np=np2;
	}
	if(np==0)
		return 1L;
	sprintf(path,"%s%lu",POSTLIST_PATH,np);
	file=fopen(path,"rt");
	if(file==NULL)
		return 1L;
	while(fgets(text,255,file)!=NULL)
	{
		sscanf(text,"%lu",&pp);
		if(pp==p)
			return np;
	}
	fclose(file);
	--np;
	sprintf(path,"%s%lu",POSTLIST_PATH,np);
	file=fopen(path,"rt");
	if(file==NULL)
		return 1L;
	while(fgets(text,255,file)!=NULL)
	{
		sscanf(text,"%lu",&pp);
		if(pp==p)
			return np;
	}
	return 1L;
}
int main()
{
	s_cgi *cgi;
	pid_t sub;
	int r;
	
	char *arg;
	char path[256];
	char path2[256];
	char left[256];
	char right[256];
	char links[256];
	FILE *file;
	unsigned long np=1L;
	unsigned long start=0L;
	unsigned long p=0L;
	unsigned long last=0xffffffff;
	unsigned long ps=0xffffffff;
	bool mustard=false;
	
	cgi=cgiInit();
	
	file = fopen(MSTD_LAST_PATH,"rt");
	if(file!=NULL)
	{
		mustard=true;
		fclose(file);
	}
	
	file = fopen(NP_LAST_PATH,"rt");
	if(file!=NULL)
	{
		fscanf(file,"%lu",&last);
		fscanf(file,"%lu",&ps);
		fclose(file);
	}
	
	printf("Content-type: text/html\n\n");
	
	arg=cgiGetValue(cgi,"np");
	if(arg!=NULL)
		sscanf(arg,"%lu",&np);
	else
	{
		arg=cgiGetValue(cgi,"start");
		if(arg!=NULL)
		{
			sscanf(arg,"%lu",&start);
			np=start/40L+1L;
		}
		else
		{
			arg=cgiGetValue(cgi,"p");
			if(arg!=NULL)
			{
				sscanf(arg,"%lu",&p);
				np=p2np(p);//not really
			}
			else
				np=1L;
		}
	}
	if(np>last)
		np=last;
	if(np<last)
		sprintf(right,"right=<a href=\\\"/ott/view?np=%lu\\\" class=\\\"right-box right\\\" >Next</a>",np+1);
	else
		sprintf(right,"%s",mustard?"right=<a href=\\\"/ott/mview\\\" class=\\\"right-box right\\\" >Mustardtime Otherthread</a>":"right=<!-- -->");
	if(np>1)
		sprintf(left,"left=<a href=\\\"/ott/view?np=%lu\\\" class=\\\"left-box left\\\" >Previous</a>",np-1);
	else
		sprintf(left,"%s","left=<!-- -->");
	
	sprintf(path2,"%s%lu",TEMP_PATH,(unsigned long)getpid());
	sprintf(links,"links=%s",path2);
	file=fopen(path2,"wt");
	if(file!=NULL)
	{
		fprintf(file,"<div class=\"pagination\" >\n");
		fprintf(file,"%lu posts\n",ps);
		fprintf(file,"&bull; <a href=\"#\" onclick=\"jumpto(); return false;\" title=\"Click to jump to page…\" >");
		fprintf(file,"Page <strong>%lu</strong> of <strong>%lu</strong></a>  &bull; <span>",np,last);
		if(np>1)
		{
			fprintf(file,"<a href=\"/ott/view?np=1\" >1</a>");
			fprintf(file,(np>6)?"<span class=\"page-dots\" > ... </span>":"<span class=\"page-sep\" >, </span>");
		}
		for(unsigned long i=((np>6)?((np<last)?(np-3):(np-4)):2);i<np;++i)
			fprintf(file,"<a href=\"/ott/view?np=%lu\" >%lu</a><span class=\"page-sep\" >, </span>",i,i);
		fprintf(file,"<strong>%lu</strong>",np);
		for(unsigned long i=np+1;i<=((np+6<=last)?((np==1)?(np+4):(np+3)):(last-1));++i)
			fprintf(file,"<span class=\"page-sep\" >, </span><a href=\"/ott/view?np=%lu\" >%lu</a>",i,i);
		if(np<last)
		{
			fprintf(file,(np+6<=last)?"<span class=\"page-dots\" > ... </span>":"<span class=\"page-sep\" >, </span>");
			fprintf(file,"<a href=\"/ott/view?np=%lu\" >%lu</a>",last,last);
		}
		if(mustard)
		{
			fprintf(file,"<span class=\"page-sep\" >, </span><a href=\"/ott/mview\" ><img src=\"/ott/prosilver/imageset/mustard_smaller.gif\" alt=\"Mustardtime\" /> <img src=\"/ott/prosilver/imageset/mustard_smaller.gif\" alt=\"Otherthread\" /> <img src=\"/ott/prosilver/imageset/mustard_smaller.gif\" alt=\"\" /></a>");
		}
		fprintf(file,"</span>\n</div>\n");
		fclose(file);
	}
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_VIEW,"-v",SIG_PATH,"-v",INF_PATH,"-v",left,"-v",right,"-v",links,"-v","title=<h2><a href=\"/ott/view?np=1\" >1190: &quot;Time&quot;</a></h2>",NP_TOP_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<p>Ch*rpin* M*stard</p>");
		
	sprintf(path,"%s%lu",UP_PATH,np);
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_VIEW,"-v",SIG_PATH,"-v",INF_PATH,"-v",left,"-v",right,"-v",links,path,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
	{
		printf("<div id=\"m%lu\" class=\"post bg2\">\n",np);
		printf("<div class=\"inner\"><span class=\"corners-top\"><span></span></span>\n");
		printf("PAGE NOT FOUND.\n");
		printf("<span class=\"corners-bottom\"><span></span></span>\n</div></div>\n");
		printf("<hr class=\"divider\"></hr>\n");
	}
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_VIEW,"-v",SIG_PATH,"-v",INF_PATH,"-v",left,"-v",right,"-v",links,NP_END_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<p>Ch*rpin* M*stard</p>");
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(RM_PATH,RM_PATH,"-f",path2,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<p>Ch*rpin* M*stard! file not deleted!</p>");
	
	return 0;
}
